package com.lofiminds.gm
{
   import flash.display.BitmapData;
   import flash.display.DisplayObject;
   import flash.display.Graphics;
   import flash.geom.ColorTransform;
   import flash.geom.Matrix;
   import flash.geom.Point;
   import flash.geom.Rectangle;
   
   public final class GameGraphics
   {
       
      
      private var bmp:BitmapData;
      
      public var hasVectorData:Boolean;
      
      private var offsetX:Number;
      
      private var offsetY:Number;
      
      private var g:Graphics;
      
      private var drawPoint:Point;
      
      private var saveX:Number;
      
      private var saveY:Number;
      
      private var drawMatrix:Matrix;
      
      public function GameGraphics(param1:Graphics, param2:BitmapData)
      {
         drawMatrix = new Matrix();
         drawPoint = new Point();
         super();
         this.g = param1;
         this.bmp = param2;
      }
      
      final public function moveTo(param1:Number, param2:Number) : void
      {
         g.moveTo(param1 - offsetX,param2 - offsetY);
      }
      
      final public function drawRect(param1:Rectangle) : void
      {
         g.drawRect(param1.x - offsetX,param1.y - offsetY,param1.width,param1.height);
         hasVectorData = true;
      }
      
      final public function clear() : void
      {
         g.clear();
         hasVectorData = false;
      }
      
      final public function lineTo(param1:Number, param2:Number) : void
      {
         g.lineTo(param1 - offsetX,param2 - offsetY);
         hasVectorData = true;
      }
      
      final public function drawGameImage(param1:GameImage, param2:Number, param3:Number, param4:Number, param5:Number = 0, param6:ColorTransform = null, param7:Number = 1) : void
      {
         drawPoint.x = param3 - offsetX - param1.originX;
         drawPoint.y = param4 - offsetY - param1.originY;
         var _loc8_:BitmapData = param1.getFrame(param2);
         if(param5 == 0 && param6 == null && param7 == 1)
         {
            bmp.copyPixels(_loc8_,_loc8_.rect,drawPoint,null,null);
         }
         else
         {
            drawMatrix.identity();
            drawMatrix.translate(-param1.originX,-param1.originY);
            drawMatrix.rotate(0 - param5);
            drawMatrix.scale(param7,param7);
            drawMatrix.translate(param1.originX,param1.originY);
            drawMatrix.translate(drawPoint.x,drawPoint.y);
            bmp.draw(_loc8_,drawMatrix,param6,null,null,false);
         }
      }
      
      public function setOffset(param1:Number, param2:Number) : void
      {
         this.offsetX = param1;
         this.offsetY = param2;
      }
      
      final public function lineStyle(param1:Number, param2:uint = 0, param3:Number = 1) : void
      {
         g.lineStyle(param1,param2,param3);
      }
      
      final public function endScreenSpace() : void
      {
         offsetX = saveX;
         offsetY = saveY;
      }
      
      final public function beginScreenSpace() : void
      {
         saveX = offsetX;
         saveY = offsetY;
         offsetX = 0;
         offsetY = 0;
      }
      
      final public function drawObject(param1:DisplayObject, param2:Number, param3:Number) : void
      {
         param1.x = param2 - offsetX;
         param1.y = param3 - offsetX;
         bmp.draw(param1,param1.transform.matrix,param1.transform.colorTransform,null,null,false);
      }
      
      final public function drawCircle(param1:Number, param2:Number, param3:Number) : void
      {
         g.drawCircle(param1 - offsetX,param2 - offsetY,param3);
         hasVectorData = true;
      }
   }
}
