package com.lofiminds.gm
{
   import flash.events.Event;
   import flash.events.EventDispatcher;
   import flash.events.KeyboardEvent;
   import flash.events.MouseEvent;
   import flash.utils.Dictionary;
   
   public final class GameInput
   {
      
      private static var mouseDispatchers:Dictionary = new Dictionary();
      
      public static var mouseLeftDown:Boolean;
      
      public static var mouseX:int;
      
      private static var keyDispatchers:Dictionary = new Dictionary();
      
      public static var MOUSE_LEFT_UP:int = 1;
      
      public static var mouseY:int;
      
      private static var keysPressed:Dictionary = new Dictionary();
      
      public static var MOUSE_LEFT_DOWN:int = 0;
       
      
      public function GameInput()
      {
         super();
      }
      
      public static function mouseUpHandler(param1:MouseEvent) : void
      {
         mouseLeftDown = false;
         dispatchMouse(MOUSE_LEFT_UP);
      }
      
      private static function dispatchMouse(param1:int) : void
      {
         var _loc2_:EventDispatcher = EventDispatcher(mouseDispatchers[param1]);
         if(_loc2_ != null)
         {
            _loc2_.dispatchEvent(new Event("mouse"));
         }
      }
      
      public static function isKeyPressed(param1:uint) : Boolean
      {
         return keysPressed[param1] != null;
      }
      
      public static function keyUpHandler(param1:KeyboardEvent) : void
      {
         keysPressed[param1.keyCode] = null;
      }
      
      public static function removeMouseListener(param1:uint, param2:Function) : void
      {
         var _loc3_:EventDispatcher = EventDispatcher(mouseDispatchers[param1]);
         _loc3_.removeEventListener("mouse",param2);
      }
      
      public static function addMouseListener(param1:int, param2:Function) : void
      {
         var _loc3_:EventDispatcher = EventDispatcher(mouseDispatchers[param1]);
         if(_loc3_ == null)
         {
            _loc3_ = new EventDispatcher();
            mouseDispatchers[param1] = _loc3_;
         }
         _loc3_.addEventListener("mouse",param2,false,0,true);
      }
      
      public static function removeKeyPressListener(param1:uint, param2:Function) : void
      {
         var _loc3_:EventDispatcher = EventDispatcher(keyDispatchers[param1]);
         _loc3_.removeEventListener("keypress",param2);
      }
      
      public static function keyDownHandler(param1:KeyboardEvent) : void
      {
         keysPressed[param1.keyCode] = true;
         var _loc2_:EventDispatcher = EventDispatcher(keyDispatchers[param1.keyCode]);
         if(_loc2_ != null)
         {
            _loc2_.dispatchEvent(new Event("keypress"));
         }
      }
      
      public static function mouseDownHandler(param1:MouseEvent) : void
      {
         mouseLeftDown = true;
         dispatchMouse(MOUSE_LEFT_DOWN);
      }
      
      public static function mouseMoveHandler(param1:MouseEvent) : void
      {
         mouseX = param1.stageX;
         mouseY = param1.stageY;
      }
      
      public static function addKeyPressListener(param1:uint, param2:Function) : void
      {
         var _loc3_:EventDispatcher = EventDispatcher(keyDispatchers[param1]);
         if(_loc3_ == null)
         {
            _loc3_ = new EventDispatcher();
            keyDispatchers[param1] = _loc3_;
         }
         _loc3_.addEventListener("keypress",param2,false,0,true);
      }
   }
}
